<?php

require_once('/usr/fallback/beroConf.php');

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'NetworkSetConfiguration';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (($this->_get['Dhcp'] == 'off') && (!isset($this->_get['IpAddress']) || !isset($this->_get['NetMask']) || !isset($this->_get['GateWay']))) {
			$this->_execResultString = 'error:invalid_parameters';
			$this->_execResult = false;
			return($this->_execResult);
		}

		$bc = new beroConf('root');

		foreach (array('lan-dhcp', 'lan-ipaddr', 'lan-netmask', 'lan-gateway', 'lan-mtu') as $lanSetting) {
			$bc->delete('root', $lanSetting);
		}

		// dhcp will be set to on
		if ($this->_get['Dhcp'] == 'on') {
			$bc->set('root', 'lan-dhcp', '1');
			return($this->_execResult);
		}

		// configure network manually
		$bc->set('root', 'lan-dhcp', '0');
		$bc->set('root', 'lan-ipaddr', sqlite_escape_string($this->_get['IpAddress']));
		$bc->set('root', 'lan-netmask', sqlite_escape_string($this->_get['NetMask']));
		$bc->set('root', 'lan-gateway', sqlite_escape_string($this->_get['GateWay']));

		// configure optional parameter NameServer
		if (isset($this->_get['NameServer'])) {
			$bc->set('root', 'lan-nameserver', sqlite_escape_string($this->_get['NameServer']));
		}

		// configure optional parameter MtuSize
		if (isset($this->_get['MtuSize'])) {
			$bc->set('root', 'lan-mtu', sqlite_escape_string($this->_get['MtuSize']));
		}

		return($this->_execResult);
	}

	function display () {

		// reboot to apply changes
		if ($this->_execResult == true) {
			exec('/sbin/reboot');
		}

		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
